Subject: Re: git reset respect remote repo (make git idiot proof)

From: Geoffrey De Smet <[email-masked]>
Date: Wed, 03 Oct 2012 17:12:34 +0200

Op 03-10-12 16:59, Ramkumar Ramachandra schreef:
> Hi Geoffrey,
>
> Geoffrey De Smet wrote:
>> [...]
>> The following commands are ok to do (because I have 2 unpushed commits):
>>   git reset --hard^1
>>   git reset --hard^2
>> but these are not and should be prevented (unless forced):
>>   git reset --hard^3
>>   git reset --hard^4
>>
>>
>> Is there any way to make git idiot proof by enabling that the local repo
>> should always respect the history of the remote repo (unless forced)?
>> Is there any way to make this a default for anyone who clones our 
>> blessed
>> repo?
>> No one that clones our blessed repo wants to come into the situation 
>> above.
>> And if they do, they can always force it.
> This makes little sense.
> Which remote?
To all remotes which have a relationship to this repo with the 
-respectRemote flag.
Normally, only the blessed remote will have this.
> What if I have multiple remotes?  Which branch? (Many
> of my branches are behind `master`).
Everytime a branch merges or rebases with a remote repository, it's 
flags the last commit of that remote repository as the pointOfNoReset 
commit.
If local branches merge or rebase with a local branch, the 
pointOfNoReset commit is transitively applied (only the last one wins).
git reset will fail to reset beyond the pointOfNoReset commit, unless 
forced.

Branches that are behind master, will have a pointOfNoReset commit in 
their history, if master goes forward afterwards, that won't affect 
those branches, not until they are merged.
>    What if I want different
> histories on different remotes?
Don't use the -respectRemote flag in the relationship between those 2 
repo's.
>   What about more advanced operations
> which implicitly 'reset' like rebase?
Them too. All operations would need to follow the -respectRemote flag's 
limitations, unless forced.
>    What if I want to rewrite
> history?
Don't use the -respectRemote flag in the relationship between this repo 
and any other repo.
Or force it.
> Ram